var __ACTION_BUTTON_LINK = "<a id=\"{ID}\" href=\"javascript:{EVENT}\" class=\"{CLASS}\" onfocus=this.blur(); style=\"{STYLE}\">{TEXT}</a>";
var __ACTION_BUTTON_SUBMIT = "<input id=\"{ID}\" type=\"submit\" onclick=\"{EVENT}\" value=\"{TEXT}\" class=\"{CLASS}\" style=\"{STYLE}\">";
var __ACTION_BUTTON_CHECKBOX = "<div class=\"{CLASS}\" style=\"{STYLE}\"><input id=\"{ID}\" type=\"checkbox\" onclick=\"{EVENT}\"><label for=\"{ID}\">{TEXT}</label></div>";
var __ACTION_BUTTON_IMAGE = "<img id=\"{ID}\" align='absmiddle' src=\"{IMAGE}\" onclick=\"{EVENT}\" class=\"{CLASS}\" style=\"{STYLE}\" onmouseover=\"this.src='{IMAGEHOVER}';\" onmouseout=\"this.src='{IMAGE}';\">";

var ACTION_BUTTON_LINK = "1";
var ACTION_BUTTON_SUBMIT = "2";
var ACTION_BUTTON_CHECKBOX = "3";
var ACTION_BUTTON_IMAGE = "4";

function ActionButton()
{
  this.ID;
  this.Text;
  this.Type = ACTION_BUTTON_LINK;
  this.Event = "";
  this.Class = "";
  this.Style = "";
  this.Image = "";
  this.ImageHover = "";
  
  this.MouseOverEvent = "";
  this.MouseOutEvent = "";
  
  this.SetImage = __SetImage;
  this.SetText = __SetText;
  
  this.Render = __RenderActionButton;
  this.Enable = __EnableActionButton;
  this.Disable = __DisableActionButton;
  this.HoverOn = __HoverOnActionButton;
  this.HoverOff = __HoverOffActionButton;
  
  this._Enabled = true;
  this._Rendered = false;
}


function __RenderActionButton()
{
  var content = "";
  
  if (this.Type == ACTION_BUTTON_LINK)
  {
    content = __ACTION_BUTTON_LINK;
  }
  else if (this.Type == ACTION_BUTTON_SUBMIT)
  {
    content = __ACTION_BUTTON_SUBMIT;
  }
  else if (this.Type == ACTION_BUTTON_CHECKBOX)
  {
    content = __ACTION_BUTTON_CHECKBOX;
  }
  else if (this.Type == ACTION_BUTTON_IMAGE)
  {
    content = __ACTION_BUTTON_IMAGE;
  }
  
  
  if( this.MouseOverEvent != "")
  {
    content = content.replace( "this.src='{IMAGEHOVER}'", this.MouseOverEvent );
  }
  if( this.MouseOutEvent != "")
  {
    content = content.replace( "this.src='{IMAGE}'", this.MouseOutEvent );
  }
  
  
  
   if( this.ImageHover != "" )
  {
    content = content.replace("{IMAGEHOVER}", this.ImageHover);
  }else
  {
   content = content.replace( "onmouseover=\"this.src='{IMAGEHOVER}';\"", "");
   content = content.replace( "onmouseout=\"this.src='{IMAGE}';\"", "");
    
  }
  
  
  
  content = content.replace("{ID}", this.ID);
  content = content.replace("{ID}", this.ID);
  content = content.replace("{TEXT}", this.Text);
  content = content.replace("{EVENT}", this.Event);
  content = content.replace("{CLASS}", this.Class);
  content = content.replace("{STYLE}", this.Style);
  content = content.replace("{IMAGE}", this.Image);
  content = content.replace("{IMAGE}", this.Image);
  
 
  
  this._Rendered = true;
  return content;
}

function __EnableActionButton()
{
  var element = Get(this.ID);
  element.disabled = false;
  this._Enabled = true;
}

function __DisableActionButton()
{
  var element = Get(this.ID);
  element.disabled = true;
  this._Enabled = false;
}

function __HoverOnActionButton()
{
  var img = Get(this.ID);
  img.src = this.ImageHover;
}

function __HoverOffActionButton()
{
  var img = Get(this.ID);
  img.src = this.Image;
}

function __SetImage( imgsrc )
{
  Get( this.ID ).src = imgsrc;
}

function __SetText( text )
{
  Get( this.ID ).innerHTML = text;
}