
function Drives(id)
{
 this.ID = "drives_" + id;
 
 this.tblList = new DataTable();
 this.tblList.Width = "100%";
 this.tblList.Cellspacing = "0";
 this.tblList.Cellpadding = "3";
 this.tblList.ID = "tblList_drives_" + id;
 
 this.tblList.ItemClass = "devicelistEven";
 this.tblList.AlternateItemClass = "devicellistOdd";
 
 this.ViewEvent = "external.ViewDrive";
 this.RecoverEvent = "external.RecoverDrive";
 
 this.Add = _AddDrive;
 this.Delete = __DeleteDrive;
 this.Render = _RenderDrive;
}

function _RenderDrive()
{
 return this.tblList.Render();
}

function _AddDrive( drive , size )
{
  //if ( Get("datatable_tbl_tblList_drives_" + this.ID ) != null )   
    // this.tblList._Rendered = true;
  
  var view = new ActionButton();
  view.Type = ACTION_BUTTON_LINK;
  view.Text = "View";
  view.Event = this.ViewEvent + "('" +drive+ "');";
  
  var recover = new ActionButton();
  recover.Type = ACTION_BUTTON_LINK;
  recover.Text = "Recover";
  recover.Event = this.RecoverEvent + "('" +drive+ "');";
  
 
  
  var div = "<div width=100% align='right'>";
  div += view.Render() + "&nbsp;&nbsp;" + recover.Render();
  div += "</div>";
  
  var div1 = "<table width=5px border=0 cellspacing=0 cellpadding=0><tr valign=\"top\"><td valign='top'>";
  div1 += drive;
  div1 += "</td></tr></table>";
  
  var item = new DataTableItemChild();
  item.Text = drive;
  item.Width = "15px";
  
  this.tblList.AddWithKey(drive, item, size, div);
  
//  this.tblList.AddWithKey(drive, drive, size, view.Render() , recover.Render());
}


function __DeleteDrive( drive )
{

  this.tblList.DeleteRow( drive );
  
}