
function AddHardDrive (  drive, size )
{
 var  d = new Drives("harddrives");
 
 
 if (Get (d.tblList._ClientID()) == null )
 {
   d.Add( drive, size);
   Get('divHardDrives').innerHTML = d.Render();
   return;
 } else
 {
   d.tblList._Rendered = true;
   d.Add( drive, size);
 }
 
  
}

function DeleteHardDrive( drive )
{
   var  d = new Drives("harddrives");
   d.Delete( drive );
}

// value : boolean
function SetDisplayHardDrive( value )
{
  SetDisplay("trHardDrive", value );
  SetDisplay("trHardDrive1", value );
  SetDisplay("trHardDrive2", value );
}


function ClearHardDrives()
{
  Get('divHardDrives').innerHTML = "";
}

//********************* Removable media *************************

function AddRemovableMedia(  drive, size )
{
  var  d = new Drives("removabledrives");
 if (Get (d.tblList._ClientID()) == null )
 {
   d.Add( drive, size);
   Get('divRemovableDrives').innerHTML = d.Render();
   return;
 } else
 {
   d.tblList._Rendered = true;
   d.Add( drive, size);
 }
}

// value : boolean
function SetDisplayRemovableMedia( value )
{
  SetDisplay("trRemovableMedia", value );
  SetDisplay("trRemovableMedia1", value );
  SetDisplay("trRemovableMedia2", value );
}



function DeleteRemovableMedia( drive )
{
   var  d = new Drives("removabledrives");
   d.Delete( drive );
}


function ClearRemovableMedia()
{
   Get('divRemovableDrives').innerHTML = "";
}
//******************************************** Drive images *******************************

function AddDriveImages(id,imagename , IsMount )
{

 var _imagename = URLDecode( imagename );
 
  var  d = new DriveImages("driveimages");
 if (Get (d.tblList._ClientID()) == null )
 {
   d.Add( id,_imagename , IsMount);
   Get('divDriveImages').innerHTML = d.Render();
   return;
 } else
 {
   d.tblList._Rendered = true;
   d.Add( id,_imagename , IsMount);
 }
}

function ModifyDriveImages(id,imagename , IsMount )
{
var  d = new DriveImages("driveimages");
 
 d.Modify( id,URLDecode( imagename ), IsMount );

}

function DeleteDriveImages( drive )
{
   var  d = new DriveImages("driveimages");
   d.Delete( drive );
}

function DriveImagesWidgetSetDislpay(value )
{
   SetDisplayBlock('divDriveImageWidget', value );
}

function ClearDriveImagesList()
{
   Get('divDriveImages').innerHTML = "";
}


//*******************  Lost partitions *****************************

function AddLostPartitions(drive , size )
{
  var  d = new Drives("LostPartitions");
 
 if (Get (d.tblList._ClientID()) == null )
 {
   d.Add( drive, size);
   Get('divLostPartitions').innerHTML = d.Render();
   return;
 } else
 {
   d.tblList._Rendered = true;
   d.Add( drive, size);
 }
 

}

function DeleteLostPartitions( drive )
{
   var  d = new Drives("LostPartitions");
   d.Delete( drive );
}

// value : boolean
function SetDisplayLostPartitions( value )
{
  SetDisplay("trLostPartitions", value );
  SetDisplay("trLostPartitions1", value );
  SetDisplay("trLostPartitions2", value );
  SetDisplay("trLostPartitions3", value );
  
}

function ClearLostPartitions()
{
  Get('divLostPartitions').innerHTML = '';
}


//*******************  drive iamges head *****************************

function AddDriveImagesHead(drive , size )
{
  var  d = new Drives("DriveImagesHead");
 
 if (Get (d.tblList._ClientID()) == null )
 {
   d.Add( drive, size);
   Get('divDriveImagesHead').innerHTML = d.Render();
   return;
 } else
 {
   d.tblList._Rendered = true;
   d.Add( drive, size);
 }
 

}

function DeleteDriveImagesHead( drive )
{
   var  d = new Drives("DriveImagesHead");
   d.Delete( drive );
}

// value : boolean
function SetDisplayDriveImagesHead( value )
{
  SetDisplay("trDriveImagesHead", value );
  SetDisplay("trDriveImagesHead1", value );
  SetDisplay("trDriveImagesHead2", value );
}

function ClearDriveImagesHead()
{
  Get('divDriveImagesHead').innerHTML = "";
}



//*******************************************************************

// state : boolean ( true - enable, false - disable )
function CreateFileTerminatorWidget(state)
{
  SetDisplayFileTerminator( true );

var f = new FileTerminator("fileterminator");

f.Status = state;

Get('divFileTerminator').innerHTML = f.Render();
  
}

//
// state : boolean ( true - enable, false - disable )
function ChangeFileTerminatorWidget( state )
{

var f = new FileTerminator("fileterminator");

f.ChangeStatus( state );
 
}
// value : boolean
function SetDisplayFileTerminator( value )
{
 SetDisplay("divFileTerminatorPanel", value );
}


// set visibility of the Create and Manage Drive Images section 
function SetDisplayDriveImages( value )
{
 SetDisplay( "tblDriveImages", value );
}

//*** test

function externalSearchLostPartitions()
{
 alert('test');
}


//***************************** UpdateWidget *******************************

//value : boolean
function SetUpdateWidgetVisible( value )
{
  SetDisplay( "divUpdateWidgetPanel", value );
}


function SetUpdateWidgetStatus( state )
{
  var u = new UpdateWidget("updatewidget");
  
  if( ! u.IsRendered() )
  {
   u.State = state;
   Get("divUpdateWidget").innerHTML = u.Render();
  }
  else
  {
    u.Set( state );
  }
}

//****************** Search widget ********************


function CreateSearchWidget()
{
  var s = new SearchWidget("search_w");
  
  if( s.IsRendered() )
    return;
    
  s.btnGo.Event = "_Search();";
  Get("divSearch").innerHTML = s.Render();
}

// value : boolean
function SetDisplaySearchWidget( value )
{
  SetDisplay( "divSearchPanel", value );
}


function _Search()
{
  var s = new SearchWidget("search_w");
  var txt  =  s.GetText();
  
  //alert( txt );
   external.OnlineSearch( txt );  // TODO : uncomment
}


//******************** Hints widget ***************************



//value : bool
function SetHintsWidgetVisible( value )
{
 SetDisplay("divHintsWidget", value );
}


//Html : string
function SetHintsWidgetHtml( Html )
{
    try
   {
   var h  = Get( "divHints" );
  h.innerHTML =  URLDecode( Html );
  SetHintsWidgetVisible(true);
  
  }
  catch(e)
  {
  SetHintsWidgetVisible(false);
  }
}

// height : string
function SetHeightHintsWidget( height )
{
   var h  = Get( "divHints" );
  h.style.height = height;
}

//disable/enable the Y scroll bar
//value : bool
function SetHintsWidgetScrollY( value )
{
   var h  = Get( "divHints" );
   if( value )
     h.style.overflowY = "scroll";
   else
     h.style.overflowY = "auto";
}


//******************** Create Virtual Drive ***************************

// value : bool
function SetDisplayCreateVirtualDrive(value)
{
  if( value )
  {
   SetDisplay("trBlank", true );
   SetClass('tdManage', 'whiteDriveImages');
   SetClass('tdManage1', 'whiteDriveImages');
   Get('imgManage').src = "manageimages.gif"
  }else
  {
   SetDisplay("trBlank", false );
   SetClass('tdManage', 'lightblueDriveImages');
   SetClass('tdManage1', 'lightblueDriveImages');
   Get('imgManage').src = "manageimages-blue.gif"
  }
}


function _ManageOnMouseOut()
{
 SetClass('spDriveImages3', '');

 if( Get('trBlank').style.display != 'none')
    SetClass('tdManage','whiteDriveImages');
 else
    SetClass('tdManage','lightblueDriveImages');
}

//**************** test functions *************

function hints()
{
  SetHintsWidgetVisible( true );
  
  NavigateHintsWidget( "http://www.google.com");
  
  SetHeightHintsWidget( "400px");
  
}

function updatevisible()
{
  SetUpdateWidgetVisible( true );
}

function testRow()
{
  SetDisplayCreateVirtualDrive( false );
}
function testRow1()
{
   SetDisplayCreateVirtualDrive( true );
}

