
function Label()
{
  this.ID = "";
  this.Text = "";
  this.Color = "";
  
  this.Show = __ShowLabel;
  this.Hide = __HideLabel;
  this.Render = __RenderLabel;
  this.SetLabelText = __SetLabelText;
  
  this.ChangeText = __ChangeText;

  this._Visible = true;
  this._Rendered = false;
}


function __RenderLabel()
{
 if (this._Rendered)
    return "";
    
  var content = "";
  var display = "block";
  
  if (!this._Visible)
  {
    display = "none";

     content += "<span id=\"label_" + this.ID + "\" style=\"display:" + display + "\">";
  }else
  {
    content += "<span id=\"label_" + this.ID + "\" >";
  }
  
//  content += "<span id=\"label_" + this.ID + "\" ";
//  if (!this._Visible) content += "style=\"display:" + display + "\" ";
//  contetn += ">";
  
  
 if(this.Color != "")
   content += "<font color="+this.Color+">";
   
  content += this.Text;
  
 if(this.Color != "")
  content += "</font>";
    
  content += "</span>";
  
  this._Rendered = true;
  
  return content;
}

function __SetLabelText(label)
{
  var element = document.getElementById("label_" + this.ID);
  
  var content = "";
  
  if(this.Color != "")
    content += "<font color="+this.Color+">";
    
  content += label;
  
  if(this.Color != "")
   content += "</font>";
   
   element.innerHTML = content;
   
}

function __HideLabel()
{
  var element = document.getElementById("label_" + this.ID);
  element.style.display = "none";
}

function __ShowLabel()
{
  var element = document.getElementById("label_" + this.ID);
  element.style.display = "block";
}


function __ChangeText()
{
 this.SetLabelText(this.Text);
 
}