
var UPDATEWIDGET_UPTODATE = "0";
var UPDATEWIDGET_UPDATES_AVAILABLE = "1";
var UPDATEWIDGET_NO_CONNECTION = "2";
var UPDATEWIDGET_MANUAL = "3";
var UPDATEWIDGET_PENDING = "4";


function UpdateWidget(id)
{
 this.ID = id;
 
 this.imgTitle = new Image();
 this.imgTitle.ID = "title_" + id;
 this.imgTitle.src = "uptodate.gif";
 
 this.lblTitle = new Label();
 this.lblTitle.ID = "lbltitle_" + id;
 this.lblTitle.Text = "title text";
 
 this.lblDes = new Label();
 this.lblDes.ID = "lbldes_" + id;
 this.lblDes.Text = "description text text text tezxt you r running the latest version sdf dsaf asdgf adsf";
 
 this.btnTitle = new ActionButton();
 this.btnTitle.ID = "btnTitle_" + id;
 this.btnTitle.Event = "__OnClickUpdateWidget('"+ id +"')";
 this.btnTitle.Text = "click me";
 
 this.btnVersionInfo = new ActionButton();
 this.btnVersionInfo.ID = "btnVersion_" + id;
 this.btnVersionInfo.Event = "external.UpdateWidgetVersionInfoClick()";
 this.btnVersionInfo.Text = "Version Info";
 
 this.btnSettings = new ActionButton();
 this.btnSettings.ID = "btnSettings_" + id;
 this.btnSettings.Event = "external.UpdateWidgetSettingsClick()";
 this.btnSettings.Text = "Settings";
 
 this.State = UPDATEWIDGET_UPTODATE;
 
 this.OnClickUpToDateEvent = "UpdateWidgetCheckForUpdatesClick()";
 this.OnClickUpdatesAvailableEvent = "UpdateWidgetDownloadUpdateClick()";
 this.OnClickNoConnection = "UpdateWidgetRetryConnectClick()";
 
 this.Render = __RenderUpdateWidget;
 this.Get = __GetUpdateWidget;
 this.Set = __SetUpdateWidget;
 this.IsRendered = __IsRenderedUpdateWidget;
 
}

function __IsRenderedUpdateWidget()
{
  if ( Get(this.ID) == null )
    return false;
  return true;
}

function __RenderUpdateWidget()
{
  var content = "";
  
  var u = this.Get( this.State );
  
  content += "<table id=" + this.ID +"  border=\"0\" cellspacing=0 cellpadding=0 width=\"100%\" >";
	  content += "<tr>";
	    content += "<td rowspan=2  width=2px    valign=top >"+ u.imgTitle.Render()  + "</td>";
	    content += "<td valign=top><b>" + u.lblTitle.Render() +  "</b><br>" +  u.lblDes.Render() ;
	    content += "</td>";
	  content += "</tr>";
	   content += "<tr>";
	    content += "<td valign=top>"+ u.btnTitle.Render() + "</td>";
	  content += "</tr>";
	  content += "<tr>";
	    content += "<td  colspan=\"2\" align=right >"+ u.btnVersionInfo.Render() +"&nbsp;&nbsp;" + u.btnSettings.Render() + "</td>";
	  content += "</tr>";
  content += "</table>";
  
  content += "<input id=\"hidState_"+ this.ID +"\" type=\"hidden\" value="+ this.State +">";
 
  return content;

}


function __GetUpdateWidget( state )
{

  switch ( state )
  {
    case UPDATEWIDGET_UPTODATE :
      this.lblTitle.Text = "Up-to-date";
      this.lblDes.Text = "You are running the latest version of Search and Recover";
      this.btnTitle.Text = "Check for updates";
      this.imgTitle.src = "uptodate.gif";
      break;
   
    case   UPDATEWIDGET_UPDATES_AVAILABLE :
      this.lblTitle.Text = "Update available";
      this.lblDes.Text = "An important update is ready to be downloaded";
      this.btnTitle.Text = "Download now";
      this.imgTitle.src = "updateavailable.gif";
      break;
      
    case UPDATEWIDGET_NO_CONNECTION :
      this.lblTitle.Text = "Could not connect";
      this.lblDes.Text = "Check your internet connection and try again";
      this.btnTitle.Text = "Retry";
      this.imgTitle.src = "couldnotconnect.gif";
      break;
      
    case UPDATEWIDGET_MANUAL :
       this.lblTitle.Text = "May not be up-to-date";
       this.lblDes.Text = "Search and Recover is not configured to automatically check for updates at startup";
       this.btnTitle.Text = "Check for updates";
       this.imgTitle.src = "unknown.gif";
       break;
        
    case UPDATEWIDGET_PENDING :
       this.lblTitle.Text = "Update pending";
       this.lblDes.Text = "Restart required";
       this.btnTitle.Text = "Restart Now";
       this.imgTitle.src = "restart.gif";
       break;
  }
  
  return this;
}

function __SetUpdateWidget( state )
{
    var u = this.Get( state );
    u.lblTitle.SetLabelText( u.lblTitle.Text );
    u.lblDes.SetLabelText( u.lblDes.Text );
    u.btnTitle.SetText( u.btnTitle.Text );
    u.imgTitle.ChangeImage();
    Get( "hidState_"+ this.ID ).value = state;
}

// internal function
function __OnClickUpdateWidget( id )
{
  var state = Get( "hidState_"+ id ).value;
  
  switch ( state )
  {
    case UPDATEWIDGET_UPTODATE :
      external.UpdateWidgetCheckForUpdatesClick();
      break;
   
    case   UPDATEWIDGET_UPDATES_AVAILABLE :
      external.UpdateWidgetDownloadUpdateClick();
      break;
      
    case UPDATEWIDGET_NO_CONNECTION :
      external.UpdateWidgetRetryConnectClick();
      break;
      
    case UPDATEWIDGET_MANUAL :
      external.UpdateWidgetCheckForUpdatesClick();
      break;
      
    case UPDATEWIDGET_PENDING :
      external.UpdateWidgetRestart();
      break;
     
     
  }
  
 
}